<template>
  <PageContainer>
    <template slot="cp_search">
      <SearchPanel
        v-model="search"
        :columns="columns"
      />
    </template>
    <template slot="header">
      <MControlPanel
        state="list"
        :can-create="canCreate"
        @on-state-button-clicked="viewForm(null)"
        :actions="actions"
        :display.sync="display"
        :selected="selected">
      </MControlPanel>
    </template>

    <template slot="content" style="background-color: white">
      <MTable
        row-key="id"
        :data-source="items"
        :columns="columns"
        :display-view="display"
        :selected.sync="selected"
        :m-loading="loading"
        :m-filter="search"
        :pagination="pagination"
        @request="onRequest"
        @on-row-clicked="viewForm">
      </MTable>
    </template>
  </PageContainer>
</template>

<script>
import PageContainer from "components/PageContainer";
import MTable from "components/datatables/MTable";
import MControlPanel from "components/MControlPanel";
import MSearchTable from "components/datatables/MSearchTable";
import {mapState} from "vuex";
import SearchPanel from "components/datatables/SearchPanel";
import get from "lodash/get";

export default {
  name: "PermissionsIndex",

  components: {SearchPanel, MSearchTable, MControlPanel, MTable, PageContainer},

  data() {
    return {
      search: null,
      pagination: {
        sortBy: null,
        descending: false,
        page: 1,
        rowsPerPage: 10,
      },
      columns: [
        {
          name: 'id', field: 'id',
          label: 'Id', align: 'left',
          required: true, sortable: true,
        },
        {
          name: 'description', field: 'description',
          label: 'Nom de la permission', align: 'left',
          required: true, sortable: true, searchable: true,
        },
        {
          name: 'slug', field: 'slug',
          label: 'Code', align: 'left',
          required: true, sortable: true, searchable: true,
        },
      ],
      loading: false,
      actions: [],
      selected: [],
      grid: false,
      display: '',
      dataSource: [],
    }
  },

  methods: {
    viewForm(row) {
      console.log('Amen!')
    },

    async onRequest(props) {
      this.loading = true
      try {
        let results = await this.$store.dispatch('permissions/index', props)
        console.log('results', results)
        this.loading = false
        this.pagination = {
          // sortBy: null,
          // descending: false,
          // page: 1,
          // rowsPerPage: 10,

          ...props.pagination,
          rowsNumber: parseInt(results.total) || 0,
        }
      } finally {
        this.loading = false
      }
    },
  },

  computed: {
    canCreate() {
      return false
    },
    canUpdate() {
      return false
    },
    ...mapState({
      items: state => get(state, 'permissions.items.data', []) || [],
    })
  },

  async mounted() {
    await this.onRequest({
      pagination: this.pagination,
      filter: this.search,
    })
  },
}
</script>

<style scoped>

</style>
